<template>
  <div>
    <div :class="color">
      <st-subtitle text="Datos del alumno" />
      <div>
        <v-row no-gutters align="center">
          <v-col md="7" align-self="center">
            <v-row>
              <v-col md="4">
                <v-label>Nombre:</v-label>
              </v-col>
              <v-col md="8">
                <v-label>{{studentName}}</v-label>
              </v-col>
            </v-row>
            <v-row>
              <v-col md="4">
                <v-label>Código del alumno:</v-label>
              </v-col>
              <v-col md="8">
                <v-label>{{studentCode}}</v-label>
              </v-col>
            </v-row>
            <v-row>
              <v-col md="4">
                <v-label>Correo electrónico:</v-label>
              </v-col>
              <v-col md="8">
                <v-label>{{studentMail}}</v-label>
              </v-col>
            </v-row>
            <v-row>
              <v-col md="4">
                <v-label>Especialidad:</v-label>
              </v-col>
              <v-col md="8">
                <v-label>{{studentCareer}}</v-label>
              </v-col>
            </v-row>
          </v-col>
          <v-col md="2.5" v-if="$store.state.role.permission">
            <template>
              <div class="rolLogin" @click="goInfo">
                <v-img src="../../images/info.png" height="100" contain></v-img>
                <div class="font-regular">Información adicional</div>
              </div>
            </template>
          </v-col>
          <v-col md="2.5" v-if="showButtonHistorial">
            <template>
              <div class="rolLogin" @click="goHistorical">
                <v-img src="../../images/historical.png" height="100" contain></v-img>
                <div class="font-regular text-center">Historial de sesiones</div>
              </div>
            </template>
          </v-col>
        </v-row>
      </div>
    </div>
    <template>
      <v-row justify="center">
        <v-dialog v-model="extraInfo" persistent max-width="1200">
          <v-card>
            <v-card-title class="headline">Información adicional del alumno</v-card-title>
            <v-card-text>
                      <v-row v-if="files.length === 0">
                        <v-col class="font-italic">No hay información adicional</v-col>
                      </v-row>
                      <v-row v-else>
                        <v-col md="12">
                          <v-data-table
                            single-select
                            :headers="headersInfo"
                            :items="files"
                            item-key="idSession"
                            sort-by="calories"
                            class="elevation-1"
                            :hide-default-footer="itemsAlumno.length <= 10"
                            loading-text="Cargando..."
                            no-data-text="No se encontraron resultados"
    no-results-text="No se encontraron resultados"
                            :loading="loading"
                          >
                            <template v-slot:item.fechaCreacion="{ item }">{{ item.fechaCreacion | formatDate }}</template>
                            <template v-slot:item.actions="{ item }">
                              <v-icon
                                medium
                                color="primary"
                                @click="download(item)"
                              >mdi-download</v-icon>
                            </template>
                          </v-data-table>
                        </v-col>
                      </v-row>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="secondary" text @click="extraInfo = false">CERRAR</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>
    </template>
    <template>
      <v-row justify="center">
        <v-dialog v-model="dialog" persistent max-width="1200">
          <v-card>
            <v-card-title class="headline">Historial de sesiones de tutoría</v-card-title>
            <v-card-text>
                <v-row>
                  <v-col md = "12">
                <v-data-table
                  single-select
                  :headers="headers"
                  :items="itemsAlumno"
                  item-key="idSession"
                  sort-by="calories"
                  class="elevation-1"
                  :hide-default-footer="itemsAlumno.length <= 10"
                  loading-text="Cargando..."
                  no-data-text="No se encontraron resultados"
    no-results-text="No se encontraron resultados"
                  :loading="loading"
                  @click:row="select"
                >

                </v-data-table>
                  </v-col>


                  <v-col md="12">
                    <st-session-data
                      :sessionName="sesion.datos.nombreTutoria"
                      :sessionDate="sesion.datos.fechaInicio"
                      :sessionState="sesion.datos.idEstado"
                      color="content-body2"
                      :historical="historical"
                      :tutor="tutor"
                    />
                  </v-col>

                  <v-col md="12">
                    <st-session-result
                      :valueCom="sesion.datos.comentario"
                      :valueDer="sesion.datos.idUnidadDerivada"
                      :planDeAccion="sesion.planDeAccion"
                      ref="sessionResult"
                      color="content-body2"
                      :historical="historical"
                    />
                  </v-col>

                </v-row>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="secondary" text @click="dialog = false">CERRAR</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>
    </template>
    <template>
      <v-row justify="center">
        <v-dialog v-model="dialog2" persistent max-width="1200">
          <v-card>
            <v-card-title class="headline">
              <v-container>
                <div md="12">
                  <v-btn x-small @click="goBack" text class="regresar">
                    <i class="fas fa-chevron-left"></i> Regresar
                  </v-btn>
                </div>
                {{titulo}}
              </v-container>
            </v-card-title>
            <v-card-text>
              <v-container>
                <v-row>
                  <v-col md="12">
                    <st-session-data
                      :sessionName="sesion.datos.nombreTutoria"
                      :sessionDate="sesion.datos.fechaInicio"
                      :sessionState="sesion.datos.idEstado"
                      color="content-body2"
                      :historical="historical"
                      :tutor="tutor"
                    />
                  </v-col>
                </v-row>
                <v-row>
                  <v-col md="12">
                    <st-session-result
                      :valueCom="sesion.datos.comentario"
                      :valueDer="sesion.datos.idUnidadDerivada"
                      :planDeAccion="sesion.planDeAccion"
                      ref="sessionResult"
                      color="content-body2"
                      :historical="historical"
                    />
                  </v-col>
                </v-row>
              </v-container>
            </v-card-text>
          </v-card>
        </v-dialog>
      </v-row>
    </template>
  </div>
</template>

<script>
import SessionData from "@/components/tutor/SessionData";
import SessionResult from "@/components/tutor/SessionResult";
export default {
  props: {
    studentName: String,
    studentCode: String,
    studentMail: String,
    studentCareer: String,
    studentID: String,
    color: String,
    nameTutorship: String,
    idTutorship:String
  },
  data() {
    return {
      showButtonHistorial:false,
      showButtonInfoAdd:false,
      files: [

      ],
      componentKey: 0,
      dialog: false,
      ids: null,
      extraInfo: false,
      loading: false,
      tutor: "",
      titulo: "Cargando...",
      historical: false,
      dialog2: false,
      headers: [
        {
          text: "Sesión",
          align: "start",
          sortable: false,
          value: "nombreTutoria"
        },
        { text: "Fecha de atención", value: "fecha" },
        { text: "Tutor quien atendió", value: "nombreTutor" },
      ],
      itemsAlumno: [],
      headersInfo: [
        {
          text: "Archivo",
          align: "start",
          sortable: false,
          value: "nombre"
        },
        { text: "Fecha de subida", value: "fechaCreacion" },
        {
          text: 'Acciones',
          value: 'actions',
          sortable: false,
          align: 'center'
        },
      ],
      sesion: {
        alumno: {
          idAlumno: "", //"d9be5677-3791-4fa4-beda-4ff36ef19d62",
          nombre: "Cargando...", //"Juan Alberto Quezada Ruiz",
          codigo: "Cargando...", //"19993256",
          correo: "Cargando...", // "juan.quezada@pucp.edu.pe",
          unidad: {
            idUnidad: "", //"73d40eb8-cbb8-4650-8e69-01c30c083b32",
            nombre: "Cargando..." //"Ingenier\u00eda Inform\u00e1tica"
          }
        },
        datos: {
          idSession: "", //"259f96d2-8ffc-45e3-bacc-be2484853ce3",
          nombreTutoria: "Cargando...", //"Tutor\u00eda de Momento",
          numeroOrden: "0", //1,
          fechaInicio: null, //"2020-07-10T14:20:00+00:00",
          comentario: "", //null,
          idUnidadDerivada: null, //null,
          idEstado: null //"Pendiente"
        },
        planDeAccion: []
      },
      sesionIni: {
        alumno: {
          idAlumno: "", //"d9be5677-3791-4fa4-beda-4ff36ef19d62",
          nombre: "Cargando...", //"Juan Alberto Quezada Ruiz",
          codigo: "Cargando...", //"19993256",
          correo: "Cargando...", // "juan.quezada@pucp.edu.pe",
          unidad: {
            idUnidad: "", //"73d40eb8-cbb8-4650-8e69-01c30c083b32",
            nombre: "Cargando..." //"Ingenier\u00eda Inform\u00e1tica"
          }
        },
        datos: {
          idSession: "", //"259f96d2-8ffc-45e3-bacc-be2484853ce3",
          nombreTutoria: "Cargando...", //"Tutor\u00eda de Momento",
          numeroOrden: "0", //1,
          fechaInicio: null, //"2020-07-10T14:20:00+00:00",
          comentario: "", //null,
          idUnidadDerivada: null, //null,
          idEstado: "Cargando..." //"Pendiente"
        },
        planDeAccion: []
      }
    };
  },
  filters: {
    formatDate: function(value) {
      if (!value) return "Cargando...";
      let options = {
        year: "numeric",
        month: "long",
        day: "numeric",
        hour12: "true",
        timeStyle: "short",
        dateStyle: "long"
      };
      let d = new Date(value).toLocaleTimeString("es", options);
      return d;
    }
  },
  watch:{
    idTutorship(newVal){
      if (newVal){
        this.ini()
      }
    }
  },
  methods: {
    goHistorical() {
      this.dialog = true;
      //this.loading = false;
    },
    async goInfo() {
      this.extraInfo = true;
      try {

        let response = await this.$api.getFileStudent(this.studentID)
        this.files = response.data.data
      } catch (e) {
        this.$store.commit("setError", e);
      }
      // let path = '/tutor/tutorias/info/' + this.datas.sesion.alumno.idAlumno
      //this.$router.push(path)
    },
    async select(item, row) {
      //this.dialog2 = true;
      //this.dialog = false;
      this.sesion = JSON.parse(JSON.stringify(this.sesionIni));
      this.titulo = "Cargando...";
      this.tutor = "Cargando...";
      try {
        let {
          data: {
            data: { sesion }
          }
        } = await this.$api.getSession(item.idSession);
        this.sesion = JSON.parse(JSON.stringify(sesion)); //sesion
        this.titulo = item.nombreTutoria;
        this.tutor = item.nombreTutor;
      } catch (e) {
        this.$store.commit("setError", e);
      }
    },
    goBack() {
      this.dialog2 = false;
      this.dialog = true;
    },
    download(item){

       window.open(item.contenido, '_blank');
    },
    async ini(){
      //verifica si el tutor tiene o no acceso para ver los documentos
      //ESTA PARTE ES PARA LAS TUTORÍAS DE MOMENTO
      // if (this.idTutorship === "51c3e3b8-af3d-4461-9223-1fb770acc1b6"){
      if (this.nameTutorship === "Tutoría de Momento"){
        //peticion para obtener la infomación
        let {data:{data:{sesiones}}} = await this.$api.getSessionsMoment(this.$store.state.role.id,this.studentID)//idAlumno,idTutor
        if (sesiones.length===0 ){
          //se trata de un tutor informal
          this.showButtonHistorial=false
          //por lo tanto no se muestra el botón de historial

        }else{
          //se trata de un tutor formal
          this.showButtonHistorial=true
          try{
            for (let it in sesiones) {
              let aux =
              "Sesion " +
              sesiones[it].numeroOrden.toString() +
              " de " +
              sesiones[it].nombreTutoria;
              sesiones[it].nombreTutoria = aux;
              let options = {
                year: "numeric",
                month: "long",
                day: "numeric",
                hour12: "true",
                timeStyle: "short",
                dateStyle: "long"
              };
              let d = new Date(sesiones[it].fecha).toLocaleTimeString(
              "es",
              options
              );
              sesiones[it].fecha = d;
            }
            sesiones.forEach(s => this.itemsAlumno.push(s));
          }catch (e){
            this.$store.commit("setError", e);
          }
        }
      }else{
      //ESTA PARTE ES PARA LAS TUTORIAS INDIVIDUALES
        this.showButtonHistorial=true
        //petición para obtener la información de las sesiones que se ha tenido entre el tutor y alumno
        //para el tipo de tutoría de esa sesión
        try{

          let {data:{data:{sesiones}}} = await this.$api.getSessionsIndividual(this.idTutorship, this.studentID)
          for (let it in sesiones) {
            let aux =
              "Sesion " +
              sesiones[it].numeroOrden.toString() +
              " de " +
              sesiones[it].nombreTutoria;
            sesiones[it].nombreTutoria = aux;
            let options = {
            year: "numeric",
            month: "long",
            day: "numeric",
            hour12: "true",
            timeStyle: "short",
            dateStyle: "long"
            };
            let d = new Date(sesiones[it].fecha).toLocaleTimeString(
              "es",
              options
            );
            sesiones[it].fecha = d;
        }
          sesiones.forEach(s => this.itemsAlumno.push(s));
        }catch (e){
          this.$store.commit("setError", e);
        }

      }

    }
  },
  mounted(){

  },
  components: {
    "st-session-data": SessionData,
    "st-session-result": SessionResult
  }
};
</script>
<style scoped lang="scss">
.rolLogin {
  height: 175px;
  width: 175px;
  margin: 10px;
  cursor: pointer;
  background-color: #f2f2f2;
  border-radius: 10px;
  display: flex;
  flex-wrap: wrap;
  align-content: center;
}
.font-regular {
  margin-left: auto;
  margin-right: auto;
  font-size: 12px;
  text-transform: uppercase;
  text-align: center;
}
.content-body2 {
  margin-top: 20px;
  padding: 20px;
  background: #f2f2f28a;
  border-radius: 10px;
}
</style>
